
#include "ALSA.h"

void alsa_get_volume(int *l,int *r)
{
	snd_mixer_t *mixer_handle;

	if( snd_mixer_open(&mixer_handle,alsa_cfg.card,alsa_cfg.mixer_device)<0 ) {
		*l=0;
		*r=0;
		return;
	}
	snd_mixer_element_read(mixer_handle,&alsa_cfg.mixer_element);
	*l=alsa_cfg.mixer_element.data.volume1.pvoices[0]-
		alsa_cfg.mixer_info.data.volume1.prange[0].min;
	if( alsa_cfg.mixer_element.data.volume1.voices > 1 )
		*r=alsa_cfg.mixer_element.data.volume1.pvoices[1]-
			alsa_cfg.mixer_info.data.volume1.prange[0].min;
	else
		*r=*l;
	*l=*l*100/alsa_cfg.mixer_range;
	*r=*r*100/alsa_cfg.mixer_range;
	snd_mixer_close(mixer_handle);
}

void alsa_set_volume(int l,int r)
{
	snd_mixer_t *mixer_handle;
	int fd;

	l=l*alsa_cfg.mixer_range/100+alsa_cfg.mixer_info.data.volume1.prange[0].min;
	r=r*alsa_cfg.mixer_range/100+alsa_cfg.mixer_info.data.volume1.prange[0].min;

	if( snd_mixer_open(&mixer_handle,alsa_cfg.card,alsa_cfg.mixer_device)<0 ) {
		printf("mixer open err\n");
		return;
	}
	alsa_cfg.mixer_element.data.volume1.pvoices[0]=l;
	if( alsa_cfg.mixer_element.data.volume1.voices > 1 )
		alsa_cfg.mixer_element.data.volume1.pvoices[1]=r;
	snd_mixer_element_write(mixer_handle,&alsa_cfg.mixer_element);
}
